import * as MessageStorage from "@effect/cluster/MessageStorage";
import type * as Runners from "@effect/cluster/Runners";
import type { Sharding } from "@effect/cluster/Sharding";
import * as ShardingConfig from "@effect/cluster/ShardingConfig";
import type * as Etag from "@effect/platform/Etag";
import type { HttpPlatform } from "@effect/platform/HttpPlatform";
import type { HttpServer } from "@effect/platform/HttpServer";
import type { ServeError } from "@effect/platform/HttpServerError";
import type { SqlClient } from "@effect/sql/SqlClient";
import type { SqlError } from "@effect/sql/SqlError";
import type { ConfigError } from "effect/ConfigError";
import * as Layer from "effect/Layer";
import type { NodeContext } from "./NodeContext.js";
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layer: <const ClientOnly extends boolean = false, const Storage extends "noop" | "sql" = "noop">(options: {
    readonly transport: "http" | "websocket";
    readonly serialization?: "msgpack" | "ndjson" | undefined;
    readonly clientOnly?: ClientOnly | undefined;
    readonly storage?: Storage | undefined;
    readonly shardingConfig?: Partial<ShardingConfig.ShardingConfig["Type"]> | undefined;
}) => ClientOnly extends true ? Layer.Layer<Sharding | Runners.Runners | MessageStorage.MessageStorage, ConfigError | (Storage extends "sql" ? SqlError : never), Storage extends "sql" ? SqlClient : never> : Layer.Layer<Sharding | Runners.Runners | MessageStorage.MessageStorage, ServeError | ConfigError | (Storage extends "sql" ? SqlError : never), Storage extends "sql" ? SqlClient : never>;
/**
 * @since 1.0.0
 * @category Layers
 */
export declare const layerHttpServer: Layer.Layer<HttpPlatform | Etag.Generator | NodeContext | HttpServer, ServeError, ShardingConfig.ShardingConfig>;
//# sourceMappingURL=NodeClusterRunnerHttp.d.ts.map